package br.ufsc.das.paxosatwar;

import br.ufsc.das.paxosatwar.roles.Acceptor;
import br.ufsc.das.paxosatwar.roles.Proposer;
import br.ufsc.das.tom.usage.TOMLayer;
import java.util.concurrent.Semaphore;

public class Consensus{
    
    private Proposer proposer;
   
    private int eid;
    
    private Object proposal = null;
    private Object decision = null;
    
    private boolean listen;
    
    private TOMLayer multicastLayer;
    
    
    /**
     * Creates a new instance of Consensus
     */
    public Consensus(TOMLayer multicastLayer, Proposer proposer, int eid) {
        this.multicastLayer = multicastLayer;
        this.proposer = proposer;
        this.eid = eid;
    }
    
    public int getId() {
        return eid;
    }
    
    public Object getProposal() {
        return proposal;
    }
    
    public Object getDecision() {
        return decision;
    }
    
    public void propose(Object value) {
        if(value == null) {
            throw new IllegalArgumentException("A proposed value cannot be null");
        }
        proposal = value;
        proposer.startExecution(eid, proposal);
    }
    
    
    /**
     * Called by the acceptor to informa about a decision
     *
     * @param value decision value
     */
    public void learn(Object value) {
        decision = value;
        this.multicastLayer.decided(this);
    }
}
