package br.ufsc.das.paxosatwar.messages;

import java.io.Serializable;

/* Proofs to freezed consensus.
 * This class can contain proofs for two consensus. 
 * The freezed one, and the next one (if have).
 */

public class CollectProof implements Serializable {
    
    /* Proofs to freezed consensus */
    private FreezeProof proofIn;
    
    /* Proofs to next consensus, if have next - after the freezed one */    
    private FreezeProof proofNext;
    
    /*The new leader id*/
    private int newLeader;
    
    
    /** Creates a new instance of CollectProof */
    public CollectProof(FreezeProof proofIn, FreezeProof proofNext, int newLeader) {
        this.proofIn = proofIn;
        this.proofNext = proofNext;
        this.newLeader = newLeader;
    }
    
    
    public RequestAutenticator[] getAutenticators(boolean in){
        if(in){
            return getAutenticatorsIn();
        }else{
            return getAutenticatorsNext();
        }
    }
    
    private RequestAutenticator[] getAutenticatorsIn(){
        if(this.proofIn != null){
            return this.proofIn.getAutenticators();
        }
        return null;
    }
    
    private RequestAutenticator[] getAutenticatorsNext(){
        if(this.proofNext != null){
            return this.proofNext.getAutenticators();
        }
        return null;
    }
    
    public FreezeProof getProofs(boolean in){
        if(in){
            return this.proofIn;
        }else{
            return this.proofNext;
        }
    }
    
    public int getLeader(){
        return this.newLeader;
    }
}
