/*
 * FreezeProof.java
 *
 * Created on 15 de Agosto de 2006, 15:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.paxosatwar.messages;

import java.io.Serializable;

 

/**
 *
 * @author edualchieri
 *
 * Proofs for one (freezed) consensus.
 */
public class FreezeProof implements Serializable{
 
    private int pid;
    private int eid;
    private int round;
    
    private Object weak;
    private Object strong;
    private Object decide;
    
    private RequestAutenticator[] aut;
    
    /** Creates a new instance of FreezeProof */
    public FreezeProof(int pid, int eid, int round, 
            Object weak, Object strong, Object decide, RequestAutenticator[] aut) {
        
        this.pid = pid;
        this.eid = eid;
        this.round = round;
        
        this.weak = weak;
        this.strong = strong;
        this.decide = decide;
        
        this.aut = aut;
    }

    public RequestAutenticator[] getAutenticators(){
        return this.aut;
    }
    
    public int getPid() {
        return pid;
    }
    
    public int getEid() {
        return eid;
    }
    
    public int getRound() {
        return round;
    }
    
    public Object getWeak() {
        return weak;
    }

    public Object getStrong() {
        return strong;
    }
    
    public Object getDecide() {
        return decide;
    }
    
    public String toString() {
        return "W="+str(weak)+" S="+str(strong)+" D="+str(decide);
    }
    
    private String str(Object obj) {
        return (obj == null)?"*":obj.toString();
    }
}
