package br.ufsc.das.paxosatwar.messages;

/**
 * This class work as a factory of messages used in the paxos protocol.
 */

public class MessageFactory{
    
    public static final int PROPOSE = 44781;
    public static final int WEAK    = 44782;
    public static final int STRONG  = 44783;
    public static final int DECIDE  = 44784;
    public static final int FREEZE  = 44785;
    public static final int COLLECT = 44786;
    
    private int from;
    
    public MessageFactory(int from) {
        this.from = from;
    }
    
    public PaxosMessage createPropose(int id, int round, Object value, 
            Object proof) {
        return new PaxosMessage(PROPOSE,id,round, from, value, proof);
    }
    
    public PaxosMessage createWeak(int id, int round, Object value) {
        return new PaxosMessage(WEAK,id,round, from, value);
    }
   
    public PaxosMessage createStrong(int id, int round, Object value) {
        return new PaxosMessage(STRONG,id,round, from, value);
    }

    public PaxosMessage createDecide(int id, int round, Object value) {
         return new PaxosMessage(DECIDE,id,round, from, value);
    }

    public PaxosMessage createFreeze(int id, int round) {
        return new PaxosMessage(FREEZE,id,round, from);
    }
    
    public PaxosMessage createCollect(int id, int round, Object proof) {
        return new PaxosMessage(COLLECT,id,round, from, null, proof);
    }
}
