/*
 * LeaderModule.java
 *
 * Created on 7 de Agosto de 2006, 14:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.paxosatwar.roles.util;

import br.ufsc.das.tom.usage.TOMLayer;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Semaphore;

/**
 *
 * @author edualchieri
 */
public class LeaderModule {
    
    private Map<Integer,List<ConsInfo>> leaderInfos = new HashMap<Integer,List<ConsInfo>>();

    /** Creates a new instance of LeaderModule */
    public LeaderModule() {
        addLeaderInfo(0,0,0);
    }
    
    public void addLeaderInfo(int c, int r, int l){
        List list = leaderInfos.get(c);
        if(list == null){
            list = new LinkedList();
            leaderInfos.put(c,list);
        }
        ConsInfo ci = findInfo(list,r);
        if(ci != null){
            ci.leaderId = l;
        }else{
            list.add(new ConsInfo(r,l));
        }
    }
    
    private ConsInfo findInfo(List l, int r){
        ConsInfo ret = null;
        for(int i = 0; i < l.size(); i++){
            ret = (ConsInfo)l.get(i);
            if(ret.round == r){
                return ret;
            }
        }
        return null;
    }
    
    public void decided(int c, int l){
        if(leaderInfos.get(c) == null){
            addLeaderInfo(c+1,0,l);
        }
    }
    
    public int getLeader(int c, int r){
        int ret = -1;
        List list = leaderInfos.get(c);
        if(list == null){
            list = new LinkedList();
            leaderInfos.put(c,list);
            List before = leaderInfos.get(c-1);
            if(before != null){
                ConsInfo ci = (ConsInfo)before.get(before.size()-1);
                list.add(new ConsInfo(r,ci.leaderId));
                ret = ci.leaderId;
            }else{
                return -1;
            }
        }else{
            ConsInfo ci = null;
            for(int i = 0; i < list.size(); i++){
                ci = (ConsInfo)list.get(i);
                if(ci.round == r){
                    ret = ci.leaderId;
                }
            }
        }
        return ret;
    }
    
    public void removeStableConsenusInfos(int c){
        List list = leaderInfos.get(c+1);
        if(list == null){//nunca vai acontecer isso!!!           
            list = new LinkedList();
            leaderInfos.put(c+1,list);
            List rm = leaderInfos.remove(c);
            ConsInfo ci = (ConsInfo)rm.get(rm.size()-1);
            list.add(new ConsInfo(0,ci.leaderId));
        }else{
            leaderInfos.remove(c);
        }
    }
    
    private class ConsInfo{
        public int round;
        public int leaderId;
        public ConsInfo(int r, int l){
            this.round = r;
            this.leaderId = l;
        }
    }
}
