/*
 * TOMReceiver.java
 *
 * Created on 28 de Setembro de 2006, 15:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom;

import br.ufsc.das.paxosatwar.messages.MessageFactory;
import br.ufsc.das.paxosatwar.roles.Acceptor;
import br.ufsc.das.paxosatwar.roles.Proposer;
import br.ufsc.das.paxosatwar.roles.util.ExecutionManager;
import br.ufsc.das.paxosatwar.roles.util.LeaderModule;
import br.ufsc.das.paxosatwar.roles.util.ProofVerifier;
import br.ufsc.das.tom.usage.TOMLayer;
import br.ufsc.das.tom.usage.TOMRequestReceiver;
import br.ufsc.das.util.CommunicationSystem;
import br.ufsc.das.util.TOMConfiguration;

/**
 *
 * @author edualchieri
 */
public abstract class TOMReceiver implements TOMRequestReceiver{
    
    private boolean tomStackCreated = false;
    
    /** Creates a new instance of TOMReceiver */
    public TOMReceiver() {

    }

    public void init(CommunicationSystem cs, TOMConfiguration conf) {
        if(tomStackCreated) {
            return;
        }
        int[] group = new int[conf.getN()];
        for(int i = 0; i < group.length;i++){
            group[i] = i;
        }
        if(cs == null){
            cs = new CommunicationSystem(conf);
        }
        int me = conf.getProcessId();
        if(me >= group.length) {
            throw new RuntimeException("you are not an acceptor");
        }
        MessageFactory messageFactory = new MessageFactory(me);
        ProofVerifier proofVerifier = new ProofVerifier(conf);
        LeaderModule lm = new LeaderModule();
        Acceptor acceptor = new Acceptor(cs, messageFactory, proofVerifier,lm,conf);
        Proposer proposer = new Proposer(cs, messageFactory, proofVerifier,conf);
        ExecutionManager manager = new ExecutionManager(acceptor, proposer,group, 
                conf.getF(), me, conf.getFreezeInitialTimeout());
        acceptor.setManager(manager);
        proposer.setManager(manager);
        TOMLayer tomLayer = new TOMLayer(manager,this,lm,acceptor,cs, conf);
        manager.setTOMLayer(tomLayer);
        cs.setTOMLayer(tomLayer);
        acceptor.setTOMLayer(tomLayer);
        tomLayer.start();
        tomStackCreated = true;
    }
    
}
