/*
 * TOMSendReceive.java
 *
 * Created on 28 de Setembro de 2006, 16:04
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom;

import br.ufsc.das.paxosatwar.messages.MessageFactory;
import br.ufsc.das.paxosatwar.roles.Acceptor;
import br.ufsc.das.paxosatwar.roles.Proposer;
import br.ufsc.das.paxosatwar.roles.util.ExecutionManager;
import br.ufsc.das.paxosatwar.roles.util.LeaderModule;
import br.ufsc.das.paxosatwar.roles.util.ProofVerifier;
import br.ufsc.das.tom.usage.TOMLayer;
import br.ufsc.das.tom.usage.TOMReplyReceiver;
import br.ufsc.das.tom.usage.TOMRequestReceiver;
import br.ufsc.das.tom.util.TOMMessage;
import br.ufsc.das.util.CommunicationSystem;
import br.ufsc.das.util.TOMConfiguration;
import java.util.concurrent.Semaphore;

/**
 *
 * @author edualchieri
 */
public abstract class TOMSendReceive implements TOMReplyReceiver,TOMRequestReceiver{

    private boolean tomStackCreated = false;
    
    private int me;
    private int[] group;
    private int sequence = 0;
    private CommunicationSystem cs;
    private Semaphore sm;
    
    /** Creates a new instance of TOMSendReceive */
    public TOMSendReceive() {
    }
       
     public void init(CommunicationSystem cs, TOMConfiguration conf) {
         
         //////// sender side ///////////////////
        this.cs = cs;
        this.cs.setTOMReplyReceiver(this);
        this.me = conf.getProcessId();
        this.group = new int[conf.getN()];
        for(int i = 0; i < group.length;i++){
            group[i] = i;
        }
        this.sm = new Semaphore(1);
        ///////////////////////////////////////
        
        /////////////// receiver side /////////
        if(tomStackCreated) {
            return;
        }
        int[] group = new int[conf.getN()];
        for(int i = 0; i < group.length;i++){
            group[i] = i;
        }
        if(cs == null){
            cs = new CommunicationSystem(conf);
        }
        int me = conf.getProcessId();
        if(me >= group.length) {
            throw new RuntimeException("you are not an acceptor");
        }
        MessageFactory messageFactory = new MessageFactory(me);
        ProofVerifier proofVerifier = new ProofVerifier(conf);
        LeaderModule lm = new LeaderModule();
        Acceptor acceptor = new Acceptor(cs, messageFactory, proofVerifier,lm,conf);
        Proposer proposer = new Proposer(cs, messageFactory, proofVerifier,conf);
        ExecutionManager manager = new ExecutionManager(acceptor, proposer,group, 
                conf.getF(), me, conf.getFreezeInitialTimeout());
        acceptor.setManager(manager);
        proposer.setManager(manager);
        TOMLayer tomLayer = new TOMLayer(manager,this,lm,acceptor,cs, conf);
        manager.setTOMLayer(tomLayer);
        cs.setTOMLayer(tomLayer);
        acceptor.setTOMLayer(tomLayer);
        tomLayer.start();
        tomStackCreated = true;
        ///////////////////////////////////////////
    }
    
    private int getNextSequenceNumber(){
        try{
            this.sm.acquire();
        }catch(InterruptedException ie){
            ie.printStackTrace();
        }
        int id = sequence++;
        this.sm.release();
        return id;
    }
    
    public void TOMulticast(Object m) {
        cs.send(group,new TOMMessage(me,getNextSequenceNumber(),m,
                                        CommunicationSystem.TOM_REQUEST_MSG));
    }
}
