package br.ufsc.das.tom;

import br.ufsc.das.util.CommunicationSystem;
import br.ufsc.das.tom.util.TOMMessage;
import br.ufsc.das.util.TOMConfiguration;
import java.util.concurrent.Semaphore;
import br.ufsc.das.tom.usage.TOMReplyReceiver;

public abstract class TOMSender implements TOMReplyReceiver{
    private int me;
    private int[] group;
    private int sequence = 0;
    private CommunicationSystem cs;
    private Semaphore sm;
    
    /** Creates a new instance of TOMulticastSender */
    public TOMSender() {
    }
    
    public void init(CommunicationSystem cs, TOMConfiguration conf) {
        this.cs = cs;
        this.cs.setTOMReplyReceiver(this);
        this.me = conf.getProcessId();
        this.group = new int[conf.getN()];
        for(int i = 0; i < group.length;i++){
            group[i] = i;
        }
        this.sm = new Semaphore(1);
    }
    
    private int getNextSequenceNumber(){
        try{
            this.sm.acquire();
        }catch(InterruptedException ie){
            ie.printStackTrace();
        }
        int id = sequence++;
        this.sm.release();
        return id;
    }
    
    public void TOMulticast(Object m) {
        cs.send(group,new TOMMessage(me,getNextSequenceNumber(),m,
                                        CommunicationSystem.TOM_REQUEST_MSG));
    }
    
}
