/*
 * TOMClientPerformanceTest.java
 *
 * Created on 22 de Maio de 2006, 14:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.demo;

import br.ufsc.das.tom.usage.TOMReplyReceiver;
import br.ufsc.das.tom.TOMSender;
import br.ufsc.das.tom.util.TOMMessage;
import br.ufsc.das.util.Storage;
import br.ufsc.das.util.TOMConfiguration;
import br.ufsc.das.util.CommunicationSystem;

import java.util.concurrent.Semaphore;

/**
 *
 * @author edualchieri
 */
public class TOMClientPerformanceDemo extends TOMSender{
    
    private Storage st;
    private int exec;
    private Semaphore sm = new Semaphore(0);
    private Semaphore mutex = new Semaphore(1);
    private int id = 0;
    private int count = 0;
    private CommunicationSystem cs;
    private int f;
    
    /** Creates a new instance of TOMClientPerformanceTest */
    public TOMClientPerformanceDemo(int exec) {
        this.exec = exec;
        this.st = new Storage(exec);
        //id for this client
        int id = Math.abs((int) System.currentTimeMillis());
        //create the configuration object
        TOMConfiguration conf = new TOMConfiguration(id);
        //create the communication system
        cs = new CommunicationSystem(conf);
        //the number of suported faults
        this.f = conf.getF();
        //initialize the TOM sender
        this.init(cs, conf);
    }
    
    private void run(){
        for(int i = 0; i < exec; i++){
            Object[] obj = new Object[2];
            obj[0] = id;
            obj[1] = "Eduardo"+id;
            //obj[1] = "eu sou cliente";
            //obj[2] = "confidencialidade";
            
            //br.ufsc.das.util.Logger.println("Enviando "+i);
            long t = System.nanoTime();
            this.TOMulticast(obj);
            //----- only for compute the latency ------------//
            try{
                this.sm.acquire();
            }catch(Exception e){
                e.printStackTrace();
            }
            this.st.store(System.nanoTime() - t);
            //------------------------------------------------//
        }
        //br.ufsc.das.util.Logger.println("Average time for "+exec+" executions = "+this.st.getAverage(true));
        //br.ufsc.das.util.Logger.println("Standard desviation for "+exec+" executions = "+this.st.getDP(true));
        System.exit(0);
    }
    
    public void TOMReplyReceive(Object reply){
        try{
            //to compute once a time
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        Object[] obj = (Object[])reply;
        
        if(Integer.parseInt(obj[0].toString()) == id){
            ////br.ufsc.das.util.Logger.println("Recebeu resposta: "+obj[1]);
            count++;
            if(count > this.f){
                id++;
                count = 0;
                this.sm.release();
            }
        }
        this.mutex.release();
    }
    
    public static void main(String[] args){
        int e = 100;
        try{
            e = Integer.parseInt(args[0]);
        }catch(Exception ex){
        }
        new TOMClientPerformanceDemo(e).run();
    }
    
}
