/*
 * TOMClientPerformanceTest.java
 *
 * Created on 22 de Maio de 2006, 14:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.demo;

import br.ufsc.das.tom.usage.TOMReplyReceiver;
import br.ufsc.das.tom.TOMSender;
import br.ufsc.das.tom.util.TOMMessage;
import br.ufsc.das.util.Storage;
import br.ufsc.das.util.TOMConfiguration;
import br.ufsc.das.util.CommunicationSystem;

import java.util.concurrent.Semaphore;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author edualchieri
 */
public class TOMClientThroughput extends TOMSender{
    
    private Storage st;
    private int exec;
    private int argSize;
    private int interval;

    private int id = 0;

    private CommunicationSystem cs;
    private int f;
    private int n;
    private int currentId = 0;

        
    public TOMClientThroughput(int id, int exec, int interval, int argSize) {
        this.id = id;
        this.exec = exec;
        this.argSize = argSize;
        this.interval = interval;
        this.st = new Storage(exec/2);
        //id for this client
        this.currentId = 0;
        //create the configuration object
        TOMConfiguration conf = new TOMConfiguration((int)id);
        //create the communication system
        cs = new CommunicationSystem(conf);
        //the number of suported faults
        this.f = conf.getF();
        this.n = conf.getN();
        br.ufsc.das.util.Logger.startInstant = System.currentTimeMillis();
        //initialize the TOM sender
        this.init(cs, conf);
    }
    
    private void run(){
        
        for(int i = 0; i < exec; i++){
          try {
                int currId = currentId;
                Object[] obj = new Object[2];
                obj[0] = currId;
                obj[1] = new byte[argSize];
                //obj[0] = id;
                //obj[1] = "Eduardo"+id;
                //obj[1] = "eu sou cliente";
                //obj[2] = "confidencialidade";
                //System.out.println("Enviando " + i);
                ////br.ufsc.das.util.Logger.println(", currentId = " + currentId);
                //last_send_instant = System.nanoTime();
                this.TOMulticast(obj);
                
                currentId+=1;
                
                if (i!=0 && i%1000==0){
                    System.out.println(i+"/"+exec+ " messages sent");
                }
                else if (i==0){
                    //sleeps one second after first packet to allow connections to be properly set up
                    Thread.sleep(1000);
                }
                
                if (interval>0){
                    //sleeps interval ms before sending next request
                    Thread.sleep(interval);
                }

                //------------------------------------------------//
          } catch (InterruptedException ex) {
                Logger.getLogger(TOMClientLatency.class.getName()).log(Level.SEVERE, null, ex);
          }
           
            //------------------------------------------------//
        }
       
        System.exit(0);
    }
    
    public void TOMReplyReceive(Object reply){
        
    }
    
    public static void main(String[] args){
        if (args.length < 4){
            System.out.println("Usage: java TomClientThroughput <process id (>=1000)> <number of messages> <interval (ms)> <argument size (bytes)>");
            System.exit(1);
        }
        int id = new Integer(args[0]).intValue();
        int execs = new Integer(args[1]).intValue();
        int interval = new Integer(args[2]).intValue();
        int argSize = new Integer(args[3]).intValue();
        
        if (id<1000){
            System.out.println("Error: process id needs to be greater or equal than 1000");
            System.exit(1);
        }
        
        new TOMClientThroughput(id, execs, interval, argSize).run();
    }
    
}
