/*
 * TOMTest.java
 *
 * Created on 11 de Maio de 2006, 14:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.demo;

import br.ufsc.das.tom.TOMSendReceive;
import br.ufsc.das.tom.usage.TOMRequestReceiver;
import br.ufsc.das.tom.util.TOMMessage;
import br.ufsc.das.util.CommunicationSystem;
import br.ufsc.das.util.TOMConfiguration;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author edualchieri
 */
public class TOMDemo extends TOMSendReceive{
    
    private int expected = 1;
    private List<TOMMessage> received = new LinkedList<TOMMessage>();
    private TOMConfiguration conf;
    
    /** Creates a new instance of TOMTest */
    public TOMDemo(int id, int expected) {
        super();
        conf = new TOMConfiguration(id);
        this.expected = expected;
    }
    
    private void run(){
        //create the communication system
        CommunicationSystem cs = new CommunicationSystem(conf);
        
        //initialize "server" and "client" side,i.e.,
        //biuld the TOM stack and initialize the sender
        this.init(cs,conf);
        
        if(conf.getN() == (conf.getProcessId()+1)){
            //send the messages
            for(int i = 0; i < expected; i++){
                this.TOMulticast("m");
            }
        }
    }
    
    
    //abstract method of TOMSender
    public void TOMReplyReceive(Object msg){}
    
    //abstract method of TOMReceiver
    public void TOMRequestReceive(TOMMessage msg){
        received.add(msg);
        if(received.size() == expected){
            //br.ufsc.das.util.Logger.println("p"+conf.getProcessId()+" list "+received);
            System.exit(0);
        }
    }
    
     public static void main(String[] args){
        int id = -1;
        int expected = 100;
        try{
            id = Integer.parseInt(args[0]);
            expected = Integer.parseInt(args[1]);
        }catch(Exception e){
            //br.ufsc.das.util.Logger.println("Use: java TOMTest <processId> <number of messages>");
            System.exit(0);
        }
        //to be able to send and receive all messages before
        //others process calls System.exit(0).
        if(expected < 100){
            expected = 100;
        }
        
        new TOMDemo(id, expected).run();
    }
}
