/*
 * TOMServerPerformanceTest.java
 *
 * Created on 22 de Maio de 2006, 14:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.demo;

import br.ufsc.das.tom.TOMReceiver;
import br.ufsc.das.tom.usage.TOMRequestReceiver;
import br.ufsc.das.tom.util.TOMMessage;
import br.ufsc.das.util.TOMConfiguration;
import br.ufsc.das.util.CommunicationSystem;

/**
 *
 * @author edualchieri
 */
public class TOMServerLatency extends TOMReceiver{
    
    private CommunicationSystem cs;
    private int id;
    private long numDecides=0;
    private long lastDecideTimeInstant;
    
    /** Creates a new instance of TOMServerPerformanceTest */
    public TOMServerLatency(int id) {
        this.id = id;
    }
    
    private void run(){
        //create the configuration object
        TOMConfiguration conf = new TOMConfiguration(id);
        //create the communication system
        cs = new CommunicationSystem(conf);
        //build the TOM server stack
        this.init(cs,conf);
    }
    
    public void TOMRequestReceive(TOMMessage msg){
        long receiveInstant =  System.currentTimeMillis();
              
        TOMMessage reply = new TOMMessage(id,msg.getSequence(),
                msg.getContent(),CommunicationSystem.TOM_REPLY_MSG);
        cs.send(new int[]{msg.getSender()},reply);
        
        if (numDecides == 0){
            lastDecideTimeInstant = receiveInstant;
        }
        else if (numDecides%1000 == 0) {
            long elapsedTime = receiveInstant - lastDecideTimeInstant;
            double opsPerSec = 1000.0/(elapsedTime/1000.0);
            System.out.println("Last 1000 decisions were done at a rate of " + Math.round(opsPerSec) + " per second");
            numDecides = -1;
        }
        numDecides++;
    }
    
    public static void main(String[] args){
        int id = -1;
        try{
            id = Integer.parseInt(args[0]);
        }catch(Exception e){
            System.out.println("Use: java TOMServerLatency <processId>");
            System.exit(0);
        }
        new TOMServerLatency(id).run();
    }
    
}
