/*
 * TOMServerPerformanceTest.java
 *
 * Created on 22 de Maio de 2006, 14:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.demo;

import br.ufsc.das.tom.TOMReceiver;
import br.ufsc.das.tom.usage.TOMRequestReceiver;
import br.ufsc.das.tom.util.TOMMessage;
import br.ufsc.das.util.TOMConfiguration;
import br.ufsc.das.util.CommunicationSystem;

/**
 *
 * @author edualchieri
 */
public class TOMServerThroughput extends TOMReceiver{
    
    private CommunicationSystem cs;
    private int id;
    private int interval;
    private long numDecides=0;
    private long lastDecideTimeInstant;
    private long max=0;
    
    /** Creates a new instance of TOMServerPerformanceTest */
    public TOMServerThroughput(int id, int interval) {
        this.id = id;
        this.interval = interval;
    }
    
    private void run(){
        //create the configuration object
        TOMConfiguration conf = new TOMConfiguration(id);
        //create the communication system
        cs = new CommunicationSystem(conf);
        //build the TOM server stack
        this.init(cs,conf);
    }
    
    public void TOMRequestReceive(TOMMessage msg){
        long receiveInstant =  System.currentTimeMillis();          
        numDecides++;
        if (numDecides == 1){
            lastDecideTimeInstant = receiveInstant;
        }
        else if (numDecides==interval) {
            long elapsedTime = receiveInstant - lastDecideTimeInstant;
            double opsPerSec_ = ((double)interval)/(elapsedTime/1000.0);
            long opsPerSec = Math.round(opsPerSec_);
            if (opsPerSec>max)
                max = opsPerSec;
            System.out.println("Last "+interval+" decisions were done at a rate of " + opsPerSec + " ops per second");
            System.out.println("Maximum throughput until now: " + max + " ops per second");
            numDecides = -1;
        }
        
    }
    
    public static void main(String[] args){
        int id = -1;
        int interval = -1;
        try{
            id = Integer.parseInt(args[0]);
            interval = Integer.parseInt(args[1]);
        }catch(Exception e){
            System.out.println("Use: java TOMServerThroughput <processId> <measurement interval in messages>");
            System.exit(0);
        }
        new TOMServerThroughput(id,interval).run();
    }
    
}
