

/*
 * RequestTimeoutInfo.java
 *
 * Created on 3 de Outubro de 2006, 14:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.timer;

import br.ufsc.das.tom.usage.*;
import br.ufsc.das.tom.timer.RTLeaderChange;
import br.ufsc.das.tom.timer.RTCollect;
import br.ufsc.das.util.TOMConfiguration;
import br.ufsc.das.util.TOMUtil;
import java.security.SignedObject;

/**
 *
 * @author edualchieri
 */
public class RTInfo {
    
    private boolean[] timeout;
    private TOMConfiguration conf;
    private int reqId;
    private int timeoutNum;
    
    private SignedObject[] collect;
    private TOMLayer tom;
    
    private boolean collected = false;
    private boolean nlSent = false;
    
    /** Creates a new instance of RequestTimeoutInfo */
    public RTInfo(TOMConfiguration conf, int reqId, int timeoutNum, TOMLayer tom) {
        this.conf = conf;
        this.reqId = reqId;
        this.timeoutNum = timeoutNum;
        this.tom = tom;
        timeout = new boolean[conf.getN()];
    }
    
    public int getTimeoutNum(){
        return this.timeoutNum;
    }
    
    public boolean getTimeout(int a){
        return this.timeout[a];
    }
    
    
    public void timeout(int a){
        timeout[a] = true;
        if(countTimeouts() > conf.getF() && !timeout[conf.getProcessId()]){
            timeout[conf.getProcessId()] = true;
            tom.sendTimeoutMessage(reqId,timeoutNum);
            tom.timer.restartTimer(reqId);
        }
        if(countTimeouts() > 2*conf.getF() && !collected){
            collected = true;
            
            tom.timer.stopMonitoring(reqId);
            tom.execManager.stop();
            int newLeader = (reqId+timeoutNum-1)%conf.getN();
            int last = -1;
            if(tom.getInExec() != -1){
                last = tom.getInExec();
            }else{
                last = tom.getLastExec();
            }
            //br.ufsc.das.util.Logger.println(reqId+" Mandando collect para "+newLeader);
            RTCollect c = new RTCollect(newLeader,last,reqId,timeoutNum);
            tom.sendCollectMessage(reqId,timeoutNum,c);
        }
    }
    
    private int countTimeouts(){
        int c = 0;
        for(int i = 0; i < timeout.length; i++){
            if(timeout[i]){
                c++;
            }
        }
        return c;
    }
    
    public void collect(SignedObject c, int a){
        if(collect == null){
            collect = new SignedObject[conf.getN()];
        }
        collect[a] = c;
        if(countCollect() > 2*conf.getF() && !nlSent){
            
            nlSent = true;
            RTCollect[] rtc = new RTCollect[collect.length];
            for(int i = 0; i < collect.length; i++){
                if(collect[i] != null){
                    try{
                        rtc[i] = (RTCollect) collect[i].getObject();
                    }catch(Exception e){
                        e.printStackTrace();
                    }
                }
            }
            int start = TOMUtil.getStartLeader(rtc,conf.getF());
            RTLeaderChange rtLC = new RTLeaderChange(this.collect,conf.getProcessId(),start);
            tom.sendNewLeaderMessage(reqId,timeoutNum,rtLC);
        }
    }
    
    private int countCollect(){
        int c = 0;
        for(int i = 0; i < collect.length; i++){
            if(collect[i] != null){
                c++;
            }
        }
        return c;
    }
    
}
