/*
 * RequestTimeoutMessage.java
 *
 * Created on 3 de Outubro de 2006, 14:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.timer;

import br.ufsc.das.util.CommunicationSystem;
import br.ufsc.das.util.SystemMessage;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

/**
 *
 * @author edualchieri
 */
public class RTMessage extends SystemMessage{
    
    private int rtType;
    private int reqId;
    private int timeout;
    private int from;
    
    private Object content;
    
   public RTMessage(){}
    
    
    /** Creates a new instance of RequestTimeoutMessage */
    public RTMessage(int rtType, int reqId, int timeout, int from, Object content) {
        super(CommunicationSystem.RT_MSG);
        this.rtType = rtType;
        this.reqId = reqId;
        this.timeout = timeout;
        this.from = from;
        this.content = content;
    }
    
    public void writeExternal(ObjectOutput out)
    throws IOException{
        super.writeExternal(out);
        out.writeInt(rtType);
        out.writeInt(reqId);
        out.writeInt(timeout);
        out.writeInt(from);
        out.writeObject(content);
    }
    
    public void readExternal(ObjectInput in)
    throws IOException,
            ClassNotFoundException{
        super.readExternal(in);
        rtType = in.readInt();
        reqId = in.readInt();
        timeout = in.readInt();
        from = in.readInt();
        content = in.readObject();
    }
    
    public int getRTType(){
        return this.rtType;
    }
    
    public int getReqId(){
        return this.reqId;
    }
    
    public int getTimeout(){
        return this.timeout;
    }
    
    public int getFrom(){
        return this.from;
    }
    
    public Object getContent(){
        return this.content;
    }
}
