

/*
 * RequestTimeoutTask.java
 *
 * Created on 10 de Agosto de 2006, 14:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.timer;

import br.ufsc.das.tom.usage.*;
import br.ufsc.das.tom.util.TOMMessage;
import java.util.LinkedList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.locks.ReentrantLock;

/**
 *
 * @author edualchieri
 */
public class RTTimer extends Timer{
    
    
    private TOMLayer tom;
    
    private List<RTTask> monitoring = new LinkedList<RTTask>();
    
    private RTTask firstMonitoring = null;
    
    private ReentrantLock lock;
    
    /*
      Ver se precisa colocar semaforo em tudos estes acessos a lista...
      Ver o esquema de escolher um lider faltoso q n�o manda a newLeader msg( vai pro proximo timer da req?).
      Testar se o lider n�o ordenar uma req do meio da seguencia, ex.: 5
     */
    
    /** Creates a new instance of RequestTimeoutTask */
    public RTTimer(TOMLayer tom){
        this.tom = tom;
        this.lock = new ReentrantLock();
    }
    
    public void stopMonitoring(int reqId){
        lock.lock();
        for(int i = 0; i < monitoring.size();i++){
            if(monitoring.get(i).getReqId() == reqId){
                restart(monitoring.get(i),monitoring.get(i).getTimeoutNum());
            }else{
                monitoring.get(i).cancel();
            }
        }
        lock.unlock();
    }
    
    public void restartMonitoring(int reqId){
        lock.lock();
        RTTask tmp = null;
        for(int i = 0; i < monitoring.size();i++){
            tmp = monitoring.get(i);
            /*if(tmp.getReqId() == reqId){
                restart(tmp,tmp.getTimeoutNum());
            }else{*/
                restart(tmp,tmp.getTimeoutNum());
            //}
        }
        lock.unlock();
    }
    
    private boolean isMonitoring(int reqId){
        for(int i = 0; i < monitoring.size();i++){
            if(monitoring.get(i).getReqId() == reqId){
                return true;
            }
        }
        return false;
    }
    
    public boolean monitoring(int reqId){
        lock.lock();
        if(firstMonitoring != null && firstMonitoring.getReqId() == reqId){
            lock.unlock();
            return true;
        }else if(!isMonitoring(reqId)){
            RTTask t = new RTTask(this,reqId,0);
            this.schedule(t,this.tom.getConf().getRequestTimeout());
            monitoring.add(t);
            firstMonitoring = t;
            lock.unlock();
            return true;
        }
        lock.unlock();
        return false;
    }
    
    public void restartTimer(int reqId){
        lock.lock();
        RTTask task  = null;
        for(int i = 0; i < monitoring.size();i++){
            task = monitoring.get(i);
            if(task.getReqId() == reqId){
                restart(task,task.getTimeoutNum()+1);
                break;
            }
        }
        lock.unlock();
    }
    
    public void restartTimer(int reqId, int timeoutNum){
        lock.lock();
        RTTask task  = null;
        for(int i = 0; i < monitoring.size();i++){
            task = monitoring.get(i);
            if(task.getReqId() == reqId){
                restart(task,timeoutNum);
                break;
            }
        }
        lock.unlock();
    }
    
    private void restart(RTTask task, int timeoutNum){
        task.cancel();
        RTTask t = new RTTask(this,task.getReqId(),timeoutNum);
        this.schedule(t,this.tom.getConf().getRequestTimeout()*(t.getTimeoutNum()+1));
        int index = monitoring.indexOf(task);
        if(index >= 0){
            monitoring.remove(index);
            monitoring.add(index,t);
        }else{
            monitoring.add(t);
        }
        if(firstMonitoring != null && firstMonitoring.equals(task)){
            firstMonitoring = t;
        }
    }
    
    public void cancelTimer(int reqId){
        lock.lock();
        RTTask task  = null;
        for(int i = 0; i < monitoring.size();i++){
            task = monitoring.get(i);
            if(task.getReqId() == reqId){
                task.cancel();
                monitoring.remove(i);
                if(firstMonitoring != null && firstMonitoring.equals(task)){
                    firstMonitoring = null;
                }
                break;
            }
        }
        lock.unlock();
    }
    
    public void timeout(RTTask task){
        lock.lock();
        ////br.ufsc.das.util.Logger.println(task.getReqId()+" deu o timeout... "+task.getTimeoutNum());
        if(firstMonitoring != null && firstMonitoring.equals(task)){
            firstMonitoring = null;
        }
        lock.unlock();
        if(tom.requestTimeout(task.getReqId(), task.getTimeoutNum())){
            RTTask t = new RTTask(this,task.getReqId(),task.getTimeoutNum()+1);
            ////br.ufsc.das.util.Logger.println(t.getReqId()+" remonitorar... "+t.getTimeoutNum());
            this.schedule(t,this.tom.getConf().getRequestTimeout()*(t.getTimeoutNum()+1));
            lock.lock();
            int index = monitoring.indexOf(task);
            if(index >= 0){
                monitoring.remove(index);
                monitoring.add(index,t);
            }else{
                monitoring.add(t);
            }
            lock.unlock();
        }else{
            ////br.ufsc.das.util.Logger.println(task.getReqId()+" remover... "+task.getTimeoutNum());
            lock.lock();
            monitoring.remove(task);
            lock.unlock();
            tom.checkTimer();
        }
        
    }
}
