

/*
 * DeliveredEntry.java
 *
 * Created on 26 de Setembro de 2006, 14:15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.util;

import br.ufsc.das.util.Configuration;
import br.ufsc.das.util.TOMConfiguration;

/**
 *
 * @author edualchieri
 */
public class DeliveredEntry {
    
    public boolean[] acks;
    public int consId;
    public SetEntry[] msgs;
    
    private TOMConfiguration conf;
    
    /** Creates a new instance of DeliveredEntry */
    public DeliveredEntry(int consId, SetEntry[] msgs, TOMConfiguration conf){
        this.acks = new boolean[conf.getN()];
        this.conf = conf;
        this.consId = consId;
        this.msgs = msgs;
    }
    
    public int[] getNotAcks(){
        int num = conf.getN() - countAcks();
        int[] ret = new int[num];
        int pos = 0;
        for(int i = 0; i < acks.length; i++){
            if(i != conf.getProcessId() && !acks[i]){
                ret[pos] = i;
                pos++;
            }
        }
        //br.ufsc.das.util.Logger.println("(DeliveryEntry) ("+ consId +") getNotAcks vai retornar");
        return ret;
    }
    
    public RequestRecoveryMessage getRRMsg(){
        return new RequestRecoveryMessage(msgs,conf.getProcessId(),consId);
    }
    
    public boolean isReady(){
        for(int i = 0; i < acks.length; i++){
            if(i != conf.getProcessId() && !acks[i]){
                return false;
            }
        }
        return true;
    }
    
    public int countAcks(){
        int count = 1;//me
        for(int i = 0; i < acks.length; i++){
            if(i != conf.getProcessId() && acks[i]){
                count++;
            }
        }
        return count;
    }
    
    public boolean equals(Object o){
        if(o instanceof DeliveredEntry){
            DeliveredEntry e = (DeliveredEntry)o;
            return e.consId == this.consId;
        }
        return false;
    }
    
    public boolean ack(int p){
        acks[p] = true;
        return isReady();
    }
}

