

/*
 * TOMulticastSet.java
 *
 * Created on 21 de Mar�o de 2006, 10:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.tom.util;

import br.ufsc.das.util.TOMUtil;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.concurrent.Semaphore;



/**
 *
 * @author edualchieri
 */
public class TOMSet extends LinkedList implements Serializable{
    
    private Semaphore mutex = new Semaphore(1);
    
    /** Creates a new instance of TOMulticastSet */
    public TOMSet() {
    }
    
    
    public SetEntry removeHash(byte[] hash){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            if(TOMUtil.equalsHash(hash,se.hash)){
                this.remove(i);
                this.mutex.release();
                return se;
            }
        }
        this.mutex.release();
        return null;
    }
    
    public SetEntry removeMsg(TOMMessage msg){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            if(se.msg.equals(msg)){
                this.remove(i);
                this.mutex.release();
                return se;
            }
        }
        this.mutex.release();
        return null;
    }
    
     public SetEntry removeMsg(int reqId){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            int cId = se.msg.getSender()+se.msg.getSequence();
            if(cId == reqId){
                this.remove(i);
                this.mutex.release();
                return se;
            }
        }
        this.mutex.release();
        return null;
    }
    
    public SetEntry getHash(byte[] hash){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            if(TOMUtil.equalsHash(hash,se.hash)){
                this.mutex.release();
                return se;
            }
        }
        this.mutex.release();
        return null;
    }
    
    
     public byte[] getHash(int i){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        
        byte[] res = ((SetEntry)this.get(i)).hash;
        
        this.mutex.release();
        return res;
    }
    
    
    
     public SetEntry getMsg(TOMMessage msg){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            if(se.msg.equals(msg)){
                this.mutex.release();
                return se;
            }
        }
        this.mutex.release();
        return null;
    }
    
    
    public boolean containsHash(byte[] hash){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            if(TOMUtil.equalsHash(hash,se.hash)){
                this.mutex.release();
                return true;
            }
        }
        this.mutex.release();
        return false;
    }
    
     public boolean containsMsg(TOMMessage msg){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            if(se.msg.equals(msg)){
                this.mutex.release();
                return true;
            }
        }
        this.mutex.release();
        return false;
    }
     
    /*
     * Retorna true se contem a mensagens identificada por id.
     * id = msg.getSender+msg.getSequence;
     */
    public boolean containsMsg(int id){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        SetEntry se = null;
        for(int i = 0; i < this.size();i++){
            se = (SetEntry) this.get(i);
            int cId = se.msg.getSender()+se.msg.getSequence();
            if(cId == id){
                this.mutex.release();
                return true;
            }
        }
        this.mutex.release();
        return false;
    } 
     
    
   public void addElement(Object o){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
         
        this.add(o);
        
        this.mutex.release();
   } 
     
    
    public void insertAll(TOMSet tom){
        try{
            this.mutex.acquire();
        }catch(Exception e){
            e.printStackTrace();
        }
        for(Iterator<SetEntry> i = tom.iterator(); i.hasNext();){
            insert(i.next());
        }
         this.mutex.release();
    }
    
    public void insert(SetEntry elem){
       
        this.add(elem);
       
    }
        
    public boolean equals(Object o){
        if(o instanceof TOMSet){
            TOMSet cs = (TOMSet)o;
            int meSize = this.size();
            int csSize = cs.size();
            if(meSize != csSize){
                return false;
            }
            TOMMessage elem1 = null;
            TOMMessage elem2 = null;
            for(int i = 0; i < meSize; i++) {
                elem1 = ((SetEntry)this.get(i)).msg;
                elem2 = ((SetEntry)cs.get(i)).msg;
                if(!elem1.equals(elem2)){
                     return false;
                 }
            }
            return true;
        }
        return false;
    }
}
