

/*
 * SystemCommunication.java
 *
 * Created on 10 de Maio de 2006, 17:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.util;

import br.ufsc.das.paxosatwar.messages.PaxosMessage;
import br.ufsc.das.paxosatwar.roles.Acceptor;
import br.ufsc.das.paxosatwar.roles.Proposer;
import br.ufsc.das.Connection;
import br.ufsc.das.tom.usage.TOMReplyReceiver;
import br.ufsc.das.tom.timer.RTMessage;
import br.ufsc.das.util.ReceivedMessage;
import br.ufsc.das.tom.usage.TOMLayer;
import br.ufsc.das.tom.util.RequestRecoveryMessage;
import br.ufsc.das.tom.util.TOMMessage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import static br.ufsc.das.paxosatwar.messages.MessageFactory.*;

import static java.lang.System.out;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.TimeUnit;
/**
 *
 * @author edualchieri
 */

public class CommunicationSystem extends Connection implements Runnable{
    
    public static int PAXOS_MSG = 0;
    public static int TOM_REQUEST_MSG = 1;
    public static int TOM_REPLY_MSG = 2;
    public static int RR_MSG = 3; //RequestRecoveryMessage
    public static int RT_MSG = 4; //RequestTimeoutMessage
    
    private Proposer proposer;
    private Acceptor acceptor;
    private TOMLayer tomLayer;
    private TOMReplyReceiver tomReplyRec;
    
    private LinkedBlockingQueue inQueue = new LinkedBlockingQueue();
    protected MessagesHandle ser;
    /** Creates a new instance of SystemCommunication */
    public CommunicationSystem(Configuration conf) {
        super(conf);
        initMessagesHandle();
        new Thread(this).start();
    }
    
    protected void initMessagesHandle(){
        this.ser = new MessagesHandle(this);
    }
    
    public void run(){
        while(true){
            try{
                ReceivedMessage msg = (ReceivedMessage)inQueue.take();
                //br.ufsc.das.util.Logger.println("(Comm System) Recebi msg de " + msg.getFrom());
                deliverToApp(msg);
            }catch(Exception e){
                e.printStackTrace();
            }
        }
    }
    
    public void setProposer(Proposer proposer){
        this.proposer = proposer;
    }
    
    public void setTOMLayer(TOMLayer tomLayer){
        this.tomLayer = tomLayer;
    }
    
    public void setTOMReplyReceiver(TOMReplyReceiver rec){
        this.tomReplyRec = rec;
    }
    
    public void setAcceptor(Acceptor acceptor){
        this.acceptor = acceptor;
    }
    
    public void send(int[] targets, SystemMessage msg){
        /*
        if (msg.getType()==PAXOS_MSG){
            //br.ufsc.das.util.Logger.print("A enviar PAXOS MSG " + msg.toString()  + "para ");
            for (int i=0; i<targets.length; i++){
                //br.ufsc.das.util.Logger.print(" " + targets[i] + " ");           
            }
             //br.ufsc.das.util.Logger.println("");
        }
        
        if (msg.getType()==TOM_REQUEST_MSG){
            //br.ufsc.das.util.Logger.print("A enviar TOM_REQUEST_MSG para ");
            for (int i=0; i<targets.length; i++){
                //br.ufsc.das.util.Logger.print(" " + targets[i] + " ");           
            }
            //br.ufsc.das.util.Logger.println("");
        }
        
        if (msg.getType()==TOM_REPLY_MSG){
            //br.ufsc.das.util.Logger.print("A enviar TOM_REPLY_MSG para ");
            for (int i=0; i<targets.length; i++){
                //br.ufsc.das.util.Logger.print(" " + targets[i] + " ");
            }
            //br.ufsc.das.util.Logger.println("");
        }
        
        if (msg.getType()==RR_MSG){
            //br.ufsc.das.util.Logger.print("A enviar RR_MSG para ");
            for (int i=0; i<targets.length; i++){
                //br.ufsc.das.util.Logger.print(" " + targets[i] + " ");            
            }
            //br.ufsc.das.util.Logger.println("");
        }
        
        if (msg.getType()==RT_MSG){
            //br.ufsc.das.util.Logger.print("A enviar RT_MSG para ");
            for (int i=0; i<targets.length; i++){
                //br.ufsc.das.util.Logger.print(" " + targets[i] + " ");           
            }
            //br.ufsc.das.util.Logger.println("");
        }
        */
        super.send(targets,ser.getData(msg));
    }
    
    public void deliver(ReceivedMessage msg){
        try{
            inQueue.put(msg);
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    public void deliverToApp(ReceivedMessage msg){
        ser.processData(msg);
    }
    
    public void processTOMRequestMsg(TOMMessage m){
        this.tomLayer.deliver(m);
    }
    
    public void processTOMReplyMsg(TOMMessage m){
        this.tomReplyRec.TOMReplyReceive(m.getContent());
    }
    
    public void processRRMsg(RequestRecoveryMessage m){
        this.tomLayer.deliverRecoveryRequest(m);
    }
    
     public void processRTMsg(RTMessage m){
        this.tomLayer.deliverTimeoutRequest(m);
    }
    
    public void processPaxosMsg(PaxosMessage paxosMsg){
        if(paxosMsg.getPaxosType() == COLLECT){
            proposer.deliver(paxosMsg);
        }else {
            acceptor.deliver(paxosMsg);
        }
    }
}
