

/*
 * MessagesSerializer.java
 *
 * Created on 18 de Maio de 2006, 16:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.util;

import br.ufsc.das.paxosatwar.messages.PaxosMessage;
import br.ufsc.das.tom.timer.RTMessage;
import br.ufsc.das.util.ReceivedMessage;
import br.ufsc.das.tom.usage.RequestRecover;
import br.ufsc.das.tom.util.RequestRecoveryMessage;
import br.ufsc.das.tom.util.TOMMessage;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import static br.ufsc.das.util.CommunicationSystem.*;

/**
 *
 * @author edualchieri
 */
public class MessagesHandle{
    
    private CommunicationSystem cs;
    /** Creates a new instance of MessagesSerializer */
    public MessagesHandle(CommunicationSystem cs) {
        this.cs =cs;
    }
    
    /*protected void processData(ReceivedMessage msg,int type, ObjectInputStream obIn) throws Exception{
        if(type == TOM_REQUEST_MSG){
            TOMMessage tomMsg = getTOMMsg(obIn);
            if(tomMsg.getSender() == msg.getFrom()){
                cs.processTOMRequestMsg(tomMsg);
            }
        }else if(type == TOM_REPLY_MSG){
            TOMMessage tomMsg = getTOMMsg(obIn);
            if(tomMsg.getSender() == msg.getFrom()){
                cs.processTOMReplyMsg(tomMsg);
            }
        }else if (type == RR_MSG){
            RequestRecoveryMessage rrMsg = (RequestRecoveryMessage)obIn.readObject();
            if(rrMsg.getFrom() == msg.getFrom()){
                cs.processRRMsg(rrMsg);
            }
        }else if (type == RT_MSG){
            RTMessage rtMsg = (RTMessage)obIn.readObject();
            if(rtMsg.getFrom() == msg.getFrom()){
                cs.processRTMsg(rtMsg);
            }
        }else{// if (type == PAXOS_MSG){
            PaxosMessage pMsg = getPaxosMsg(obIn);
            if(pMsg.getFrom() == msg.getFrom()){
                cs.processPaxosMsg(pMsg);
            }
        }
    }*/
    
    
    protected void processData(SystemMessage sm, ReceivedMessage msg){
        if(sm.getType() == TOM_REQUEST_MSG){
            //br.ufsc.das.util.Logger.println("(MessagesHandle) Eh um TOM_REQUEST");
            TOMMessage tomMsg = (TOMMessage)sm;
            if(tomMsg.getSender() == msg.getFrom()){
                cs.processTOMRequestMsg(tomMsg);
            }
        }else if(sm.getType() == TOM_REPLY_MSG){
            //br.ufsc.das.util.Logger.println("(MessagesHandle) Eh um TOM_REPLY");
            TOMMessage tomMsg = (TOMMessage)sm;
            if(tomMsg.getSender() == msg.getFrom()){
                cs.processTOMReplyMsg(tomMsg);
            }
        }else if (sm.getType() == RR_MSG){
            
            RequestRecoveryMessage rrMsg = (RequestRecoveryMessage)sm;
            //br.ufsc.das.util.Logger.println("(MessagesHandle) Eh uma RR_MSG, id= "+rrMsg.getId());
            if(rrMsg.getFrom() == msg.getFrom()){
                cs.processRRMsg(rrMsg);
            }
        }else if (sm.getType() == RT_MSG){
            //br.ufsc.das.util.Logger.println("(MessagesHandle) Eh uma RT_MSG");
            RTMessage rtMsg = (RTMessage)sm;
            if(rtMsg.getFrom() == msg.getFrom()){
                cs.processRTMsg(rtMsg);
            }
        }else{// if (type == PAXOS_MSG){
            
            if (sm.getType()!=PAXOS_MSG){
                //br.ufsc.das.util.Logger.println("(MessagesHandle): Recebi msg não PAXOS que era suposto ser.");
            }
            PaxosMessage pMsg = (PaxosMessage)sm;
            //br.ufsc.das.util.Logger.println("(MessagesHandle) Eh uma msg PAXOS " + pMsg.toString());
            if(pMsg.getFrom() == msg.getFrom()){
                cs.processPaxosMsg(pMsg);
            }
        }
    }
    
    public void processData(ReceivedMessage msg){
       /* try{
            ByteArrayInputStream bIn = new ByteArrayInputStream(msg.getData());
            ObjectInputStream obIn = new ObjectInputStream(bIn);
            int type = obIn.readInt();
            processData(msg,type,obIn);
        }catch(Exception e){
            e.printStackTrace();
        }*/
        
        SystemMessage sm = null;
        try{
            ByteArrayInputStream bIn = new ByteArrayInputStream(msg.getData());
            ObjectInputStream obIn = new ObjectInputStream(bIn);
            sm = (SystemMessage) obIn.readObject();
            processData(sm,msg);
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    protected void getData(SystemMessage msg, int type, ObjectOutputStream obOut) throws Exception{
        if(type == TOM_REQUEST_MSG || type == TOM_REPLY_MSG){
            getBytes((TOMMessage)msg,obOut);
        }else if (type == RR_MSG || type == RT_MSG){
            obOut.writeObject(msg);
        }else {//if (type == PAXOS_MSG){
            getBytes((PaxosMessage)msg,obOut);
        }
    }
    
    public byte[] getData(SystemMessage msg){
        ByteArrayOutputStream bOut = new ByteArrayOutputStream();
        try{
            ObjectOutputStream obOut = new ObjectOutputStream(bOut);
            /*obOut.writeInt(msg.getType());
             
            getData(msg,msg.getType(),obOut);*/
            obOut.writeObject(msg);
            
        }catch(Exception e){
            e.printStackTrace();
        }
        
        /*if(msg.getType() == TOM_REQUEST_MSG){
            //br.ufsc.das.util.Logger.println("Req: "+bOut.toByteArray().length);
        }
         
        if(msg.getType() == TOM_REPLY_MSG){
            //br.ufsc.das.util.Logger.println("Resp: "+bOut.toByteArray().length);
        }*/
        
        return bOut.toByteArray();
    }
    
    private void getBytes(PaxosMessage msg, ObjectOutputStream obOut) throws Exception{
        obOut.writeInt(msg.getNumber());
        obOut.writeInt(msg.getRound());
        obOut.writeInt(msg.getFrom());
        obOut.writeInt(msg.getPaxosType());
        obOut.writeObject(msg.getValue());
        obOut.writeObject(msg.getProof());
    }
    
    private PaxosMessage getPaxosMsg(ObjectInputStream obIn) throws Exception{
        int number = obIn.readInt();
        int round = obIn.readInt();
        int from = obIn.readInt();
        int paxosT = obIn.readInt();
        Object value = obIn.readObject();
        Object proof = obIn.readObject();
        return new PaxosMessage(paxosT,number,round,from,value,proof);
    }
    
    private void getBytes(TOMMessage msg, ObjectOutputStream obOut) throws Exception{
        obOut.writeInt(msg.getSender());
        obOut.writeInt(msg.getSequence());
        obOut.writeObject(msg.getContent());
    }
    
    private TOMMessage getTOMMsg(ObjectInputStream obIn) throws Exception{
        int sender = obIn.readInt();
        int sequence = obIn.readInt();
        Object content = obIn.readObject();
        return new TOMMessage(sender,sequence,content,TOM_REQUEST_MSG);
    }
    
}
