/*
 * RSAKeysLoader.java
 *
 * Created on 28 de Agosto de 2006, 14:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.util;

import java.io.BufferedReader;
import java.io.FileReader;
import java.security.KeyFactory;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.EncodedKeySpec;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

import sun.misc.*;
/**
 *
 * @author edualchieri
 */
public class RSAKeysLoader {
    
    private String path;
    private PublicKey[] pubKeys;
    private PrivateKey priKey;
    private TOMConfiguration conf;
    /** Creates a new instance of RSAKeysLoader */
    public RSAKeysLoader(TOMConfiguration conf, String configHome) {
        this.conf = conf;
        
        if(configHome.equals("")){
            path = "config"+System.getProperty("file.separator")+"keys"+
                      System.getProperty("file.separator");
        }else{
            path = configHome+System.getProperty("file.separator")+"keys"+
                      System.getProperty("file.separator");
        }
    }
    
    public PublicKey[] loadPublicKeys() throws Exception{
        if(pubKeys == null){
            pubKeys = new PublicKey[conf.getN()];
            for(int i = 0; i < pubKeys.length; i++){
                pubKeys[i] = loadPublicKey(i);
            }
        }
        return pubKeys;
    }
    
    public PublicKey loadPublicKey(int id) throws Exception{
        BufferedReader r = new BufferedReader(new FileReader(path+"publickey"+id));
        String tmp = "";
        String key = "";
        while((tmp = r.readLine()) != null){
            key=key+tmp;
        }
        r.close();
        return getPublicKeyFromString(key);
        
    }
    
    public PrivateKey loadPrivateKey() throws Exception{
        if(priKey == null){
            BufferedReader r = new BufferedReader(
                    new FileReader(path+"privatekey"+conf.getProcessId()));
            String tmp = "";
            String key = "";
            while((tmp = r.readLine()) != null){
                key=key+tmp;
            }
            r.close();
            priKey = getPrivateKeyFromString(key);
        }
        return priKey;
    }
    
    private PrivateKey getPrivateKeyFromString(String key) throws Exception {
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        BASE64Decoder b64 = new BASE64Decoder();
        EncodedKeySpec privateKeySpec = new PKCS8EncodedKeySpec(b64.decodeBuffer(key));
        PrivateKey privateKey = keyFactory.generatePrivate(privateKeySpec);
        return privateKey;
    }
    
    private PublicKey getPublicKeyFromString(String key) throws Exception {
        BASE64Decoder b64 = new BASE64Decoder();
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        EncodedKeySpec publicKeySpec = new X509EncodedKeySpec(b64.decodeBuffer(key));
        PublicKey publicKey = keyFactory.generatePublic(publicKeySpec);
        return publicKey;
    }
}
