/*
 * TOMUtil.java
 *
 * Created on 18 de Setembro de 2006, 13:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.util;

import br.ufsc.das.tom.timer.RTCollect;
import java.util.Arrays;

/**
 *
 * @author edualchieri
 */
public class TOMUtil {
    
    public static int RR_REQUEST = 0;
    public static int RR_REPLY = 1;
    public static int RR_DELIVERED = 2;
    
    public static int RT_TIMEOUT = 3;
    public static int RT_COLLECT = 4;
    public static int RT_LEADER = 5;
    
    /** Creates a new instance of TOMUtil */
    public TOMUtil() {
    }
    
    
    public static int getStartLeader(RTCollect[] collect, int f){
        int[] last = new int[2*f+1];
        int p = 0;
        for(int i = 0; i < collect.length && p < last.length; i++){
            if(collect[i] != null){
                last[p++] = collect[i].getLastConsensus();
            }
        }
        Arrays.sort(last);
        int c = 0;
        for(int i = last.length -1 ; i > -1 ; i--){
            c = 0;
            for(int j = 0; j < last.length ; j++){
                if(last[i] <= last[j]){
                    c++;
                }
            }
            if(c > f){
                return last[i]+1;
            }
        }
        return last[0];
    }
    
    public static boolean goodStartLeader(RTCollect[] collect, int f, int start, int newLeader){
        int c = 0;
        for(int i = 0; i < collect.length; i++){
            if(collect[i] != null && collect[i].getNewLeader() == newLeader){
                c++;
            }
        }
        
        if(c <= f){
           return false;
        }
        
        int num = 0;
        for(int i = 0; i < collect.length; i++){
            if(collect[i] != null){
                num++;
            }
        }
        int[] last = new int[num];
        int p = 0;
        for(int i = 0; i < collect.length && p < last.length; i++){
            if(collect[i] != null){
                last[p++] = collect[i].getLastConsensus();
            }
        }
        c = 0;
        for(int i = 0 ; i < last.length ; i++){
            if((start-1) <= last[i]){
                c++;
            }
        }
        if(c > f){
            return true;
        }
        return false;
    }
    
    
    public static void print(byte[] b){
        String s = "";
        for(int i = 0; i < b.length;i++){
            s=s+b[i];
        }
        //br.ufsc.das.util.Logger.println(s);
    }
    
    public static boolean equalsHash(byte[] h1,byte[] h2){
        if(h1 == h2){
            return true;
        }
        if(h1 == null || h2 == null){
            return false;
        }
        if(h1.length != h2.length){
            return false;
        }
        for(int i = 0; i < h1.length;i++){
            if(h1[i] != h2[i]){
                return false;
            }
        }
        return true;
    }
    
}

